namespace LightBox.Providers
{
    using System;
    using System.Configuration.Provider;
    using System.IO;

	/// <summary>
	/// Base class for all image providers
	/// </summary>
    public abstract class ImageProvider : ProviderBase
    {
        /// <summary>
        /// Protected default constructor
        /// </summary>
        protected ImageProvider() { }

		/// <summary>
		/// Gets a stream for the image with the specified url.
		/// </summary>
		/// <param name="url">Url for the specified file.</param>
		/// <returns>A <see cref="Stream"/> containing the contents of the file.</returns>
		public abstract Stream GetImageByUrl(string url);
    }
}